#include <FilePanel.h>
#include <Path.h>

#include "BrowseButton.h"

BrowseButton::BrowseButton(BTextControl *handler)
	: MButton("…",new BMessage('brws'),this,minimax(20,20,20,20))
{
	target=handler;
	panel=NULL;
}


BrowseButton::~BrowseButton()
{
	delete panel;
}

void BrowseButton::MessageReceived(BMessage *message)
{
	switch(message->what)
	{
		case 'brws':
			if(!panel)
			{
				BMessenger messenger(this);
				BMessage selectmessage('slct');
				panel=new BFilePanel(B_OPEN_PANEL, 
				&messenger,
				NULL, // entry_ref* directory
				B_DIRECTORY_NODE, 
				false,  // multiple select
				&selectmessage
				);
				panel->SetButtonLabel(B_DEFAULT_BUTTON, "select");
			}
			panel->Show();
			break;
		case 'slct':
			{
				entry_ref ref;
				if(message->FindRef("refs",&ref)==B_OK)
				{
					BEntry entry(&ref);
					BPath path;
					entry.GetPath(&path);
					if(target->LockLooper())
					{
						target->SetText(path.Path());
						target->UnlockLooper();
					}
//					BMessage paste(B_PASTE);
//					paste.AddData("text/plain",B_MIME_TYPE,path.Path(),strlen(path.Path())+1);
//					Window()->PostMessage(B_SELECT_ALL,target);
//					Window()->PostMessage(&paste,target);
				}
			}
    }
}

