
#ifndef _ENCODER_H
#define _ENCODER_H

#include "KernelKit.h"
#include "ListView.h"

#include "Encoder.h"
#include "EncListItem.h"

class EncoderServer;

class Encoder
{
	sem_id sem;
	char *filename;
	BListView *lv;
	EncListItem *item;

	public:
		Encoder(sem_id id, char *name, BListView *lv, EncListItem *item);

		void Run();
		static long _encoderfunc(void *arg);
		void EncoderFunc();
};

class EncoderServer
{
		long maxthreads;
	sem_id sem;
	bool done;
	BListView *listview;

	public:
		EncoderServer(int maxthreads,BListView *lv);
		virtual ~EncoderServer();
		void Start();
		void Stop();
		void SetThreadCount(long count);
		static long _asyncacquiresem(void *arg);
		void AsyncAcquireSem();
		static long _encoderloop(void *arg);
		void EncoderLoop();
};

#pragma export on
extern "C" void DoCompression(char *name,char *destination,long bitrate, bool del, bool copyright, bool original, BListView *lv, EncListItem *listitem);
#pragma export reset

#endif
